Index: partem_s.f
===================================================================
--- partem_s.f	(revision 87ddcf7a314d90070d607f0ec7ac0a700b843abc)
+++ partem_s.f	(revision e40e335d8909b50cd784019735fcdb0c28ee19bb)
@@ -4,11 +4,11 @@
 !
 ! Copyright 2003-2005  Frank Eisenmenger, U.H.E. Hansmann,
-!                      Shura Hayryan, Chin-Ku
-! Copyright 2007       Frank Eisenmenger, U.H.E. Hansmann,
-!                      Jan H. Meinke, Sandipan Mohanty
+!                      Shura Hayryan, Chin-Ku 
+c Copyright 2007       Frank Eisenmenger, U.H.E. Hansmann,
+c                      Jan H. Meinke, Sandipan Mohanty
 !
 !
 ! **************************************************************
-
+      
       subroutine partem_s(num_rep, nequi, nswp, nmes, nsave, newsta,
      &                     switch)
@@ -20,11 +20,4 @@
 !
       include 'INCL.H'
-      
-      double precision gasc, dv, grnd, vr, addang, energ, energy, acz
-      double precision ee, rgy, temp0, delta, ra
-
-      integer i, j, nml, k, nstart, iv, nsw, iswitch, k1, num_rep1, nu
-      integer in, jn
-
       external can_weight
 ! TODO Store global coordinates in pgbpr
@@ -51,5 +44,5 @@
 !     ipoi:   Points to replica ipoi(k) which is currently
 !             at inverse temperature pbe(k)
-!     eol:    energy of each replica
+!     eol:    energy of each replica 
 !     acc:    accepatance rate of each replica
 !
@@ -62,5 +55,5 @@
       allocate(temp(num_rep), pbe(num_rep), eol(num_rep))
       allocate(acc(num_rep), ipoi(num_rep))
-
+      
       if (.not.(allocated(coor_G).and.allocated(temp)
      &          .and. allocated(pbe).and. allocated(eol)
@@ -84,5 +77,5 @@
          ipoi(i) = 0
       end do
-
+        
 
 !     READ IN TEMPERATURES
@@ -97,5 +90,5 @@
 
       open(13,file='time.d',status='unknown')
-
+      
       if(.not.newsta) then
 ! READ START Values
@@ -129,7 +122,7 @@
                   pgbpr(j, nml, i) = gbpr(j, nml)
                end do
-            end do
-         end do
-
+            end do            
+         end do
+      
 !      Equilibrization for each replica (No replica exchange move)
          do k=1,num_rep
@@ -148,6 +141,6 @@
                CALL METROPOLIS(energ,acz,can_weight)
             end do
-            write (logString, *) 
-     &         'Start energy after equilibration for replica:',k, energ
+            write(*,*) 'Start energy after equilibration for replica:', 
+     &                 k, energ
             do i=1,nvr
                iv = idvr(i)
@@ -162,5 +155,5 @@
          end do
       end if
-
+            
 ! Now begins the simulation with Multiple Markov Chains
       iswitch = 1
@@ -183,5 +176,5 @@
             end do
             CALL METROPOLIS(energ,acz,can_weight)
-!
+! 
             if(mod(nsw,nmes).eq.0) then
 ! Measure and store here all quantities you want to analyse later
@@ -202,5 +195,5 @@
                end do
             end do
-
+        
             eol(k) = energ
             acc(k) = acz
@@ -221,5 +214,5 @@
             j=i+1
             if(i.eq.num_rep) j=1
-            in=ipoi(i)
+            in=ipoi(i)      
             jn=ipoi(j)
             delta=-pbe(i)*eol(jn)-pbe(j)*eol(in)
Index: pdbread.f
===================================================================
--- pdbread.f	(revision 87ddcf7a314d90070d607f0ec7ac0a700b843abc)
+++ pdbread.f	(revision e40e335d8909b50cd784019735fcdb0c28ee19bb)
@@ -1,36 +1,35 @@
-! **************************************************************
-!
-! This file contains the subroutines: pdbread,pdbvars,atixpdb,getpar
-!
-! Copyright 2003-2005  Frank Eisenmenger, U.H.E. Hansmann,
-!                      Shura Hayryan, Chin-Ku
-! Copyright 2007       Frank Eisenmenger, U.H.E. Hansmann,
-!                      Jan H. Meinke, Sandipan Mohanty
-!
-! **************************************************************
+c **************************************************************
+c
+c This file contains the subroutines: pdbread,pdbvars,atixpdb,getpar
+c
+c Copyright 2003-2005  Frank Eisenmenger, U.H.E. Hansmann,
+c                      Shura Hayryan, Chin-Ku 
+c Copyright 2007       Frank Eisenmenger, U.H.E. Hansmann,
+c                      Jan H. Meinke, Sandipan Mohanty
+c
+c **************************************************************
 
       subroutine pdbread(pdbfil,ier)
 
-! ....................................................
-! PURPOSE: read protein atom coordinates from 'pdbfil'
-!          (no Hydrogens, only ATOM records)
-!
-! RETURNS: 0 = no errors / 1 = error
-!
-! CALLS: iopfil,iendst
-! ......................................................
+c ....................................................
+c PURPOSE: read protein atom coordinates from 'pdbfil'
+c          (no Hydrogens, only ATOM records)
+c
+c RETURNS: 0 = no errors / 1 = error
+c
+c CALLS: iopfil,iendst
+c ......................................................
+
+      implicit real*8 (a-h,o-z)
+      implicit integer*4 (i-n)
 
       include 'INCP.H'
-      
-      double precision cor
-
-      integer ier, l, iendst, lunpdb, io, iopfil, iat, i
-
-! -------------------------- input
+
+c -------------------------- input
       character*(*) pdbfil
-! -------------------------- local
+c -------------------------- local
       dimension cor(3)
       character atm*4,rsn*3,rsno*3,chn,chno,
-     &          rsid*5,rsido*5,line*132, logString*255
+     #          rsid*5,rsido*5,line*132
 
       natp=0
@@ -48,6 +47,6 @@
         lunpdb = 99
       else
-        write (logString, '(a)')
-     &    ' pdbread> empty file name to read pdb-structure'
+        write (*,'(a)') 
+     #    ' pdbread> empty file name to read pdb-structure'
 
         return
@@ -57,7 +56,7 @@
 
       if (io.le.0) then
-        write (logString, '(a,/,a)')
-     &  ' pdbread> ERROR opening file to read pdb-structure: ',
-     &  pdbfil(1:iendst(pdbfil))
+        write (*,'(a,/,a)') 
+     #  ' pdbread> ERROR opening file to read pdb-structure: ',
+     #  pdbfil(1:iendst(pdbfil))
 
         return
@@ -70,8 +69,8 @@
 
       if ( line(17:17).ne.' ' )  then
-        write (logString, '(a,/,a,/,a,/,2a)')
-     &  ' pdbread> found alternate atom location: ',
-     &  '                !',
-     &  line(:l),' in file: ',pdbfil(1:iendst(pdbfil))
+        write (*,'(a,/,a,/,a,/,2a)') 
+     #  ' pdbread> found alternate atom location: ',
+     #  '                !',
+     #  line(:l),' in file: ',pdbfil(1:iendst(pdbfil))
 
         close(lunpdb)
@@ -86,7 +85,7 @@
 
       if ((natp+1).gt.MXATP) then
-        write (logString, '(a,i5,a,/,a)')
-     &  ' pdbread>  >MXATP (',MXATP,') ATOM lines in PDB file ',
-     &  pdbfil(1:iendst(pdbfil))
+        write (*,'(a,i5,a,/,a)') 
+     #  ' pdbread>  >MXATP (',MXATP,') ATOM lines in PDB file ',
+     #  pdbfil(1:iendst(pdbfil))
 
         close(lunpdb)
@@ -97,7 +96,7 @@
 
         if ((nchp+1).gt.MXCHP) then
-          write (logString, '(a,i3,a,/,a)')
-     &    ' pdbread>  >MXCHP (',MXCHP,') chains in PDB file ',
-     &    pdbfil(1:iendst(pdbfil))
+          write (*,'(a,i3,a,/,a)') 
+     #    ' pdbread>  >MXCHP (',MXCHP,') chains in PDB file ',
+     #    pdbfil(1:iendst(pdbfil))
 
           close(lunpdb)
@@ -106,7 +105,7 @@
 
         if ((nrsp+1).gt.MXRSP) then
-          write (logString, '(a,i3,a,/,a)')
-     &    ' pdbread>  >MXRSP (',MXRSP,') residues in PDB file ',
-     &    pdbfil(1:iendst(pdbfil))
+          write (*,'(a,i3,a,/,a)') 
+     #    ' pdbread>  >MXRSP (',MXRSP,') residues in PDB file ',
+     #    pdbfil(1:iendst(pdbfil))
 
           close(lunpdb)
@@ -141,7 +140,7 @@
 
         if ((nrsp+1).gt.MXRSP) then
-          write (logString, '(a,i3,a,/,a)')
-     &    ' pdbread>  >MXRSP (',MXRSP,') residues in PDB file ',
-     &    pdbfil(1:iendst(pdbfil))
+          write (*,'(a,i3,a,/,a)') 
+     #    ' pdbread>  >MXRSP (',MXRSP,') residues in PDB file ',
+     #    pdbfil(1:iendst(pdbfil))
 
           close(lunpdb)
@@ -172,8 +171,8 @@
       goto 1
 
-    2 write (logString, '(a,/,a,/,2a)')
-     &  ' pdbread> ERROR reading ATOM line ',
-     &  line(:l),
-     &  ' from file ',pdbfil(1:iendst(pdbfil))
+    2 write (*,'(a,/,a,/,2a)') 
+     #  ' pdbread> ERROR reading ATOM line ',
+     #  line(:l),
+     #  ' from file ',pdbfil(1:iendst(pdbfil))
 
       close(lunpdb)
@@ -195,7 +194,7 @@
       else
 
-        write (logString, '(a,/,a)')
-     &  ' pdbread> NO atom coordinates selected from file ',
-     &  pdbfil(1:iendst(pdbfil))
+        write (*,'(a,/,a)') 
+     #  ' pdbread> NO atom coordinates selected from file ',
+     #  pdbfil(1:iendst(pdbfil))
 
       endif
@@ -206,31 +205,26 @@
 
       end
-! **************************************************************
+c **************************************************************
 
       subroutine pdbvars()
 
-! --------------------------------------------------------------------
-! PURPOSE: sequence,indices for selected atoms (data in INCP.H)
-!          & torsions from PDB to be used to build SMMP structure
-!
-!          ixatp(i,)
-!          = indices for SMMP atoms pointing to PDB atoms
-!            (=0, if atom not selected)
-!
-! --------------------------------- ref. point & axes
-!         ixrfpt(3,),rfpt(3,),xrfax(3,),yrfax(3,),zrfax(3,)
-!
-! CALLS:  tolost,getmol,bldmol,addend,atixpdb,setmvs,mklist,
-!         dihedr,fnd3ba,setsys,getpar,setvar,rmsdopt
-! --------------------------------------------------------------------
+c --------------------------------------------------------------------
+c PURPOSE: sequence,indices for selected atoms (data in INCP.H)
+c          & torsions from PDB to be used to build SMMP structure
+c
+c          ixatp(i,)
+c          = indices for SMMP atoms pointing to PDB atoms
+c            (=0, if atom not selected)
+c
+c --------------------------------- ref. point & axes
+c         ixrfpt(3,),rfpt(3,),xrfax(3,),yrfax(3,),zrfax(3,)
+c
+c CALLS:  tolost,getmol,bldmol,addend,atixpdb,setmvs,mklist,
+c         dihedr,fnd3ba,setsys,getpar,setvar,rmsdopt
+c --------------------------------------------------------------------
 
       include 'INCL.H'
       include 'INCP.H'
 
-      double precision dihedr, rm, av1, av2, rmsd, h, x, y, z
-
-      integer nml, nrs, nc, irb, ire, irs, i, ii, it, i1, i2, i3, i4, j1
-      integer j2, j3, j4, inew, j, ix
-
       character res*3
       dimension rm(3,3),av1(3),av2(3),h(3)
@@ -242,20 +236,20 @@
       do nc=1,nchp  ! PDB chains
 
-! =============================== SMMP molecule
+c =============================== SMMP molecule
         nml=nml+1
         if (nml.gt.mxml) then
-          write (logString, '(a,i4,2a)')' pdbvars> NUMBER of chains > '
-     &                          ,mxml,' in ',' ?'
+          write(*,'(a,i4,2a)')' pdbvars> NUMBER of chains > '
+     #                          ,mxml,' in ',' ?'
           stop
         endif
         ntlml=nml
-! ----------------------------- 'nmml' = ChainID
+c ----------------------------- 'nmml' = ChainID
         nmml(nml)=chnp(nc)
 
-! ======================================== get sequence
+c ======================================== get sequence
 
         irb=nrs+1
         ire=nrs+nchrsp(nc)
-! ----------------------------- # of 1st & last residue
+c ----------------------------- # of 1st & last residue
         irsml1(nml)=irb
         irsml2(nml)=ire
@@ -266,6 +260,6 @@
 
           if (nrs.gt.mxrs) then
-            write (logString, '(a,i4,2a)') 
-     &         ' pdbvars> NUMBER of residues > ', mxrs, ' in ',' ?'
+            write(*,'(a,i4,2a)') ' pdbvars> NUMBER of residues > '
+     #                       ,mxrs,' in ',' ?'
             stop
           endif
@@ -277,10 +271,10 @@
 
           if (.not.flex.and.irs.eq.irb.and.seq(nrs)(1:3).eq.'pro')
-     &      seq(nrs)='pron'  ! only ECEPP/3
+     #      seq(nrs)='pron'  ! only ECEPP/3
 
         enddo ! residues
 
-! ======================== get initial coords. for molecule 'nml'
-!                          with library values for deg. of freedom
+c ======================== get initial coords. for molecule 'nml'
+c                          with library values for deg. of freedom
 
         call getmol(nml)   ! assemble res. data from libraries
@@ -295,9 +289,9 @@
         call atixpdb(nml)  ! get 'ixatp'
 
-! -------------------------- 'load' SMMP variable information
+c -------------------------- 'load' SMMP variable information
         call setmvs(nml)   ! moving sets
         call mklist(nml)   ! interaction lists
 
-! ================================= get variables for 'nml'
+c ================================= get variables for 'nml'
 
         ii=ivrml1(nml)
@@ -362,11 +356,11 @@
         nvr = ivrml1(ntlml)+nvrml(ntlml)-1
 
-! ================================= global parameters for 'nml'
-
-! +++++++++++
+c ================================= global parameters for 'nml'
+
+c +++++++++++
        inew=0
 
        if (inew.eq.1) then
-! ++++++++++++++++++++++++
+c ++++++++++++++++++++++++
 
         call setvar(nml,vlvr)
@@ -375,6 +369,6 @@
         call rmsdopt(nml,1,nrs,ixatp,xatp,yatp,zatp,0,rm,av1,av2,rmsd)
 
-! ---------------------------- retrieve ref. coords.
-!                     & transform acc. to opt. rmsd
+c ---------------------------- retrieve ref. coords.
+c                     & transform acc. to opt. rmsd
         do i=1,3
           ii=ixrfpt(i,nml)
@@ -402,7 +396,7 @@
         call bldmol(nml)  ! finally build SMMP molecule
 
-! ++++++++++++++++
+c ++++++++++++++++
        else  ! old
-! ++++++++++++++++
+c ++++++++++++++++
 
         call fnd3ba(nml,i1,i2,i3)  ! three 1st bb atoms in SMMP (e.g. n,ca,c')
@@ -412,5 +406,5 @@
         ixrfpt(3,nml)=i3
 
-! -------------------------------- retrieve ref. coords.
+c -------------------------------- retrieve ref. coords.
         do i=1,3
           ii=ixrfpt(i,nml)
@@ -421,6 +415,6 @@
             zat(ii)=zatp(ix)
           else
-            write (logString, '(3a)') ' pdbvars> missing PDB atom ',
-     &         nmat(ii), ' is ref. point for SMMP - cannot proceed !'
+            write(*,'(3a)') ' pdbvars> missing PDB atom ',nmat(ii),
+     #       ' is ref. point for SMMP - cannot proceed !'
           endif
         enddo
@@ -432,10 +426,10 @@
         call rmsdopt(nml,1,nrs,ixatp,xatp,yatp,zatp,0,rm,av1,av2,rmsd)
 
-! ++++++++++
+c ++++++++++
        endif
-! ++++++++++
-
-       write (logString, *) ' '
-       write (logString, *) ' Initial RMSD ',rmsd
+c ++++++++++
+
+       write(*,*) ' '
+       write(*,*) ' Initial RMSD ',rmsd
 
       enddo ! chains(molecules)
@@ -443,19 +437,17 @@
       return
       end
-! ***************************
+c ***************************
       subroutine atixpdb(nml)
 
-! --------------------------------------------------------------------
-! PURPOSE: get ixatp - pointer of each SMMP atom to corresponding atom
-!                      of reference structure loaded in 'INCP.H'
-!                      (=0 if no corr. atom in ref. str.)
-!
-! CALLS:   toupst
-! --------------------------------------------------------------------
+c --------------------------------------------------------------------
+c PURPOSE: get ixatp - pointer of each SMMP atom to corresponding atom
+c                      of reference structure loaded in 'INCP.H'
+c                      (=0 if no corr. atom in ref. str.)
+c
+c CALLS:   toupst
+c --------------------------------------------------------------------
 
       include 'INCL.H'
       include 'INCP.H'
-
-      integer irs, nml, i1, i2, iat, ix, i
 
       character*4 atm
@@ -484,7 +476,7 @@
               endif
             enddo
-
-!            write (logString, '(8a)') ' pdbvars> ',atm,' not found in '
-!     #       ,chnp(nc),' ',rsidp(irs),' ',rsnmp(irs)
+               
+c            write(*,'(8a)') ' pdbvars> ',atm,' not found in '
+c     #       ,chnp(nc),' ',rsidp(irs),' ',rsnmp(irs)
 
           endif
@@ -492,32 +484,27 @@
     1     ixatp(iat)=ix
 
-        enddo   ! SMMP atoms of 'irs'
+        enddo   ! SMMP atoms of 'irs' 
       enddo   ! residues
 
       return
       end
-! **************************
+c **************************
       subroutine getpar(nml)
 
       include 'INCL.H'
 
-      double precision tol, h1, h2, h3, x1, x2, x3, d, z1, z2, z3, y1
-      double precision y2, y3, yp1, yp2
-
-      integer i1, nml, i2, i3, i
-
       parameter (TOL = 1.d-12)
 
-! Obtain molecule-fixed system (J,K,L) for 1st 3 bb-atoms,
-! -> determine global parameters: shifts dX,dY,dZ
-! & angles alpha,beta,gamma [rad], put into 'gbpr'
-!
-! CALLS: none
-!
+c Obtain molecule-fixed system (J,K,L) for 1st 3 bb-atoms,
+c -> determine global parameters: shifts dX,dY,dZ
+c & angles alpha,beta,gamma [rad], put into 'gbpr'
+c 
+c CALLS: none
+c
 
       i1=ixrfpt(1,nml)  ! from 'INCL.H'
       i2=ixrfpt(2,nml)
       i3=ixrfpt(3,nml)
-! -------------------------------------- Shifts
+c -------------------------------------- Shifts
       gbpr(1,nml) = xat(i1)
       gbpr(2,nml) = yat(i1)
@@ -527,5 +514,5 @@
         gbpr(i,nml) = 0.d0
       enddo
-! --------------------------------- J
+c --------------------------------- J
       h1=xat(i2)
       h2=yat(i2)
@@ -541,5 +528,5 @@
       x2=x2/d
       x3=x3/d
-! --------------------------------- L
+c --------------------------------- L
       h1=xat(i3)-h1
       h2=yat(i3)-h2
@@ -556,12 +543,12 @@
       z3=z3/d
 
-! ---------------------------------- K
+c ---------------------------------- K
       y1=z2*x3-z3*x2
       y2=z3*x1-z1*x3
       y3=z1*x2-z2*x1
-
+      
       if ( ( 1.d0 - abs(y3) ) .gt. TOL )  then       ! ============ |beta| < PI/2
 
-! ----------------------------------------------- Y'
+c ----------------------------------------------- Y'
         d = sqrt( y1 * y1 + y2 * y2 )
         yp1= y1 / d
Index: protein.py
===================================================================
--- protein.py	(revision e40e335d8909b50cd784019735fcdb0c28ee19bb)
+++ protein.py	(revision e40e335d8909b50cd784019735fcdb0c28ee19bb)
@@ -0,0 +1,289 @@
+#!/usr/bin/env python
+# protein.py
+#
+# Copyright 2007       Frank Eisenmenger, U.H.E. Hansmann,
+#                      Jan H. Meinke, Sandipan Mohanty
+#
+import sys
+import smmp
+from math import *
+
+crd = 57.2957795130823
+
+def nursvr(ivr):
+    res = 0
+    for i in range(smmp.mol_i.ntlml - 1, -1, -1):
+        ifirs = smmp.mol_i.irsml1[i] - 1
+        if ivr + 1 > smmp.res_i.ivrrs1[ifirs] and smmp.mol_i.nvrml[i] > 0:
+            for j in range(smmp.mol_i.irsml2[i] - 1, ifirs - 1, -1):
+                if ivr + 1 > smmp.res_i.ivrrs1[j]  and smmp.res_i.nvrrs[j] > 0:
+                    res = j + 1
+                    return res
+    return res
+
+## Provides read-only access to SMMP's atoms. Usually, you won't initialize
+#  an Atom directly since you need to know the internal array index of the
+#  Atom in SMMP. You can get a list of all the Atoms in a Protein by using 
+#  protein.Protein.getAtoms().
+#  Various properties are accessible. See the functions' documentations for
+#  details.
+class Atom:
+    """Atoms are the basic chemical units."""
+    #TODO: insert namespace
+    
+    ## Initialize the atom with its ID. The ID is the array index of the atom
+    #  in SMMP. 
+    #       @param id index of atom in SMMP
+    def __init__(self, id):
+        self.__id = id
+    
+    def position(self):
+        """Cartesian coordinates of this atom."""
+        res = (smmp.atm_r.xat[self.__id], smmp.atm_r.yat[self.__id], smmp.atm_r.zat[self.__id])
+        return res
+    
+    def charge(self):
+        """Partial charge of this atom."""
+        return smmp.atm_r.cgat[self.__id]
+    
+    def radius(self):
+        """Van-der-Waals Radius of this atom."""
+        return smmp.solvent.rvdw[self.__id]
+        
+    def name(self):
+        return ''.join([smmp.atm_c.nmat[i][self.__id] for i in range(0,4)]).strip()
+        
+    def __str__(self):
+        return "%s at (%s, %s, %s)" % (self.name(), self.position()[0],  self.position()[1], self.position()[2])
+
+## Amino acids bound within a protein are often called residues. Strictly
+#  speaking the residue is the part that's connected to the Calpha and not part
+#  of the backbone, but we'll include the backbone atoms as well. Just like Atoms
+# Residues reference the corresponding data in SMMP and are not independent. 
+class Residue:
+    """An amino acid within a Protein."""
+    
+    ## Initialize the residue with the corresponding index in SMMP.
+    #  @param id index of residue in SMMP
+    def __init__(self, id):
+        self.__id = id
+
+    def atoms(self):
+        """Returns the list of atoms belonging to this residue."""
+        first = smmp.res_i.iatrs1[self.__id]
+        last = smmp.res_i.iatrs2[self.__id]
+        res = [Atom(i) for i in range(first - 1, last - 1)]
+        return res
+    
+        
+## Proteins are constructed from a sequence file and a configuration file or 
+#  read from a PDB file.
+class Protein:
+    """A protein is a polypeptide made of the 20 naturally occuring amino 
+    acids.
+    """
+    
+    def __init__(self, seq, var=' '):
+        """The structure of the protein is read in from a file. 
+        Pass the name of a textfile with a sequence string and--optionally--the name of a
+        variable file that describes the conformation. Or give the name of pdb
+        file---it must end with 'pdb'---that contains both information."""
+        
+        grpn = 'nh2'
+        grpc = 'cooh'
+        prevID = smmp.mol_i.ntlml - 1
+        if seq[-3:].lower() == 'pdb':
+            if smmp.mol_i.ntlml:
+                print "Sorry, but I can only read the first protein from a pdb file." 
+                raise ValueError
+            smmp.init_molecule(0, grpn, grpc, seq)
+        else:
+            smmp.init_molecule(1, grpn, grpc, seq, var)
+        self.__id = smmp.mol_i.ntlml - 1
+        if self.__id - prevID > 1:
+            print "Sorry, I don't know how to deal with multiple proteins in one sequence file, yet."
+            raise NotImplementedError
+    
+    def setOrigin(self, x, a):
+        """Sets the position of the N terminal of the protein in the global 
+        coordinate system and the orientation of the protein. Expects two 
+        tuples. The first contains the coordinates of the first atom (x, y,
+        and z) and the second contains three angles.
+        """
+        #TODO: Implement type checking
+        smmp.mol_r.gbpr[0][self.__id] = x[0]
+        smmp.mol_r.gbpr[1][self.__id] = x[1]
+        smmp.mol_r.gbpr[2][self.__id] = x[2]
+        smmp.mol_r.gbpr[3][self.__id] = a[0]
+        smmp.mol_r.gbpr[4][self.__id] = a[1]
+        smmp.mol_r.gbpr[5][self.__id] = a[2]
+
+    def origin(self):
+        r = [smmp.mol_r.gbpr[i][self.__id] for i in range(0, 3)]
+        a = [smmp.mol_r.gbpr[i][self.__id] for i in range(3, 6)]
+        return r, a
+    
+    def getDihedral(self, angle, residue):
+        try:
+            res = int(residue)
+            idx = res
+        except ValueError:
+            res = residue.split()
+            res[0] = res[0].lower()
+            res[1] = int(res[1])
+            idx = self.findResidue(res[0], res[1])
+        varIdx = ''
+        for i in range(smmp.res_i.ivrrs1[idx], smmp.res_i.ivrrs1[idx] + smmp.res_i.nvrrs[idx]):
+            varName = ''.join(list([str(smmp.var_c.nmvr[j][i]) for j in range(0, 3)]))
+            if varName == angle:
+                varIdx = i
+                break
+        if varIdx:
+            return smmp.var_r.vlvr[varIdx] * crd
+        raise KeyError, '%s not found for %s.' % (angle, residue)
+    
+    ## Residues are given by their 3-letter abbreviation and their index. 
+    #  For example, findResidue('gly', 5) returns the index of the fifth occurence
+    #  of glycine in the protein. If the residue is not found an exception is raised.
+    #
+    #  @param name 3-letter abbreviation of the residue
+    #  @param idx index of occurence of the amino acid given in name.
+    
+    def findResidue(self, name, idx = 1):
+        """Find the idxth residue of type name and return the index."""
+        res = ''.join(self.residues()).lower()
+        name = name.lower()
+        j = 0
+        try:
+            for i in range(0, idx):
+                k = res.index(name, j)
+                j = j + k
+        except:
+            raise KeyError, "%s%s not found." % (name, idx)
+        if j >=len(res):
+            raise KeyError, "%s%s not found." % (name, idx)
+        return j / 3
+        
+    def atoms(self):
+        """Returns the list of atoms belonging to this protein."""
+        first = smmp.res_i.iatrs1[smmp.mol_i.irsml1[self.__id] - 1]
+        last = smmp.res_i.iatrs2[smmp.mol_i.irsml2[self.__id] - 1]
+        res = [Atom(i) for i in range(first - 1, last - 1)]
+        return res
+    
+    def residues(self):
+        """Returns a list of the amino acids in this protein."""
+        seq = [str(c[0]) for c in smmp.res_c.seq]
+        first = smmp.mol_i.irsml1[self.__id]- 1
+        last = smmp.mol_i.irsml2[self.__id] - 1
+        return ''.join(seq).split()[first:last]
+        
+    def id(self):
+        return self.__id
+        
+    def strand(self):
+        """Returns the number of residues in a beta-strand-like configuration."""
+        maxDev = 30.0
+        phiSheet = -150.0
+        psiSheet = 150.0
+        strandCount = 0
+        ifivr = smmp.mol_i.ivrml1[self.__id]
+        i = 0
+        iv = smmp.var_i.idvr[i]
+        while iv < ifivr:
+            i += 1
+            iv = smmp.var_i.idvr[i]
+        for j in range(i, ifivr + smmp.mol_i.nvrml[self.__id]):
+            iv = smmp.var_i.idvr[j] - 1
+            name =''. join([str(smmp.var_c.nmvr[iv * 3 + k][0]) for k in range(0,3)])
+            if name == 'phi':
+                phi = smmp.var_r.vlvr[iv] * crd
+                psi = smmp.var_r.vlvr[smmp.var_i.idvr[j+1] - 1] * crd
+                if abs(phi - phiSheet) < maxDev and abs(psi - psiSheet) < maxDev:
+                    strandCount += 1
+        return strandCount
+    
+    def directionVector(self):
+        """Calculates the normalized end-to-end vector for this molecule. 
+        The first and last c_alpha carbon is used as reference."""
+        atoms = self.atoms()
+        beginning = []
+        for a in atoms:
+            if a.name().strip() == 'ca':
+                if beginning:
+                    end = a.position()
+                else:
+                    beginning = a.position()
+        res = [end[i] - beginning[i] for i in range(0,3)] 
+        sum = sqrt(reduce(lambda x, y: x + y ** 2, res))
+        res = map(lambda x: x / sum, res)
+        return res
+        
+    def contacts(self):
+        """Returns a triplet containing the total number of contacts, the number
+        of native contacts, and the hemming distance. The latter two quantities 
+        are only meaningful if a reference structure has been defined.
+        """
+        return smmp.contacts()
+
+    def hbond(self):
+        return smmp.hbond(self.__id + 1, 0)
+        
+    def energy(self):
+        return smmp.energy()
+    
+    def rgyr(self):
+        return smmp.rgyr(self.__id + 1) 
+    
+    def rmsdfun(self):
+        return smmp.rmsdfun()
+        
+    def savePDB(self, file=""):
+       """Write the current configuration to file using PDB formatting."""
+       smmp.outpdb(self.__id, file)
+       
+    def saveVariables(self, file=""):
+        """Output the current conformation in the variable format. The output 
+        can be read in again and used to restart/continue a simulation.
+        
+        @param file if empty write to standard out
+        """
+        # Same functionality as smmp.outvar(self.__id + 1, 0)
+        if not file:
+            out = sys.stdout
+        else:
+            out = open(file, 'w')
+        for i in range(smmp.mol_i.ivrml1[self.__id] - 1 , smmp.mol_i.ivrml1[self.__id] + smmp.mol_i.nvrml[self.__id] - 1):
+            if not smmp.var_l.fxvr[i]:
+                name = ''.join([str(smmp.var_c.nmvr[i * 3 + j][0]) for j in range(0,3)])
+                print >>out, nursvr(i), ':', name, ':', smmp.var_r.vlvr[i] * crd
+            else:
+                it=smmp.var_i.ityvr[i]
+                if it == 3:
+                    print >>out, nursvr(i), ':', name, ':', smmp.var_r.vlvr[i] * crd, ' &'
+        
+    def zimmer(self):
+        first = smmp.mol_i.irsml1[self.__id][0] - 1
+        last = smmp.mol_i.irsml2[self.__id][0] - 1
+        nrs = smmp.mol_i.irsml2[smmp.mol_i.ntlml - 1][0] - 1
+        smmp.zimmer(last)
+        return smmp.zimme.zimm[first:last]
+
+    def __len__(self):
+        return smmp.mol_i.irsml2[self.__id]  - smmp.mol_i.irsml1[self.__id]
+
+
+if __name__ == "__main__":
+    libdir = 'SMMP/'
+
+    smmp.epar_l.flex = 0
+    smmp.epar_l.sh2 = 0
+    smmp.epar_l.epsd = 0
+    smmp.epar_l.tesgrd = 0
+    smmp.isolty.itysol = 0
+    smmp.init_energy(libdir)
+    
+    p1 = Protein('EXAMPLES/1bdd.pdb')
+    for i in p1.atoms():
+        print i
+    print p1.getDihedral('phi', 11)
